unit Ledlp_1a;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Ledlp, StdCtrls, Menus, Buttons, ExtCtrls, TypInfo;

type
  TLEditForm = class(TForm)
    ButtonPanel: TPanel;
    NewBtn: TSpeedButton;
    OpenBtn: TSpeedButton;
    SaveBtn: TSpeedButton;
    SaveAsBtn: TSpeedButton;
    ReloadBtn: TSpeedButton;
    UndoBtn: TSpeedButton;
    RedoBtn: TSpeedButton;
    CutBtn: TSpeedButton;
    CopyBtn: TSpeedButton;
    PasteBtn: TSpeedButton;
    FindBtn: TSpeedButton;
    ReplaceBtn: TSpeedButton;
    GotoBtn: TSpeedButton;
    ForeColorBtn: TSpeedButton;
    BackColorBtn: TSpeedButton;
    SelForeColorBtn: TSpeedButton;
    SelBackColorSel: TSpeedButton;
    MainMenu: TMainMenu;
    FileMenuItem: TMenuItem;
    NewMenuItem: TMenuItem;
    OpenMenuItem: TMenuItem;
    SaveMenuItem: TMenuItem;
    SaveAsMenuItem: TMenuItem;
    N1: TMenuItem;
    ExitMenuItem: TMenuItem;
    EditMenuItem: TMenuItem;
    UndoMenuItem: TMenuItem;
    RedoMenuItem: TMenuItem;
    Line2: TMenuItem;
    CutMenuItem: TMenuItem;
    CopyMenuItem: TMenuItem;
    PasteMenuItem: TMenuItem;
    Line3: TMenuItem;
    ClearMenuItem: TMenuItem;
    ClearAllMenuItem: TMenuItem;
    DeleteMenuItem: TMenuItem;
    SelectAllMenuItem: TMenuItem;
    Line4: TMenuItem;
    FindMenuItem: TMenuItem;
    ReplaceMenuItem: TMenuItem;
    GotoLineMenuItem: TMenuItem;
    OptionsMenuItem: TMenuItem;
    ForeColorMenuItem: TMenuItem;
    BackgroundColor1: TMenuItem;
    FindNextMenuItem: TMenuItem;
    ReloadFileMenuItem: TMenuItem;
    ReadOnlyMenuItem: TMenuItem;
    Line5: TMenuItem;
    BookmarksMenuItem: TMenuItem;
    SetBookmarkMenuItem: TMenuItem;
    FindBookmarkMenuItem: TMenuItem;
    SelectForeColorMenuItem: TMenuItem;
    SelectBackColorMenuItem: TMenuItem;
    FontMenuItem: TMenuItem;
    InsertModeMenuItem: TMenuItem;
    ClearUndoMenuItem: TMenuItem;
    FindBraceMenuItem: TMenuItem;
    PopupMenu1: TPopupMenu;
    UndoPopupItem: TMenuItem;
    RedoPopupItem: TMenuItem;
    PopupLine1: TMenuItem;
    CutPopupItem: TMenuItem;
    CopyPopupItem: TMenuItem;
    PastePopupItem: TMenuItem;
    DeletePopupItem: TMenuItem;
    SelectAllPopupItem: TMenuItem;
    PopupLine2: TMenuItem;
    ClearPopupItem: TMenuItem;
    ClearAllPopupItem: TMenuItem;
    PopupLine3: TMenuItem;
    FindPopupItem: TMenuItem;
    ReplacePopupItem: TMenuItem;
    StatusPanel: TPanel;
    LineCountStatus: TPanel;
    TotalLineCount: TLabel;
    LineStatus: TPanel;
    LineNumber: TLabel;
    RowStatus: TPanel;
    RowNumber: TLabel;
    StatusLine: TPanel;
    LEdit1: TLEdit;
    ColorDialog: TColorDialog;
    HelpMenuItem: TMenuItem;
    AboutMenuItem: TMenuItem;
    SetBookmarkBtn: TSpeedButton;
    FindBookmarkBtn: TSpeedButton;
    AboutBtn: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure ExitMenuItemClick(Sender: TObject);
    procedure OpenMenuItemClick(Sender: TObject);
    procedure NewMenuItemClick(Sender: TObject);
    procedure SaveMenuItemClick(Sender: TObject);
    procedure SaveAsMenuItemClick(Sender: TObject);
    procedure ReloadFileMenuItemClick(Sender: TObject);
    procedure UndoMenuItemClick(Sender: TObject);
    procedure RedoMenuItemClick(Sender: TObject);
    procedure ClearUndoMenuItemClick(Sender: TObject);
    procedure CutMenuItemClick(Sender: TObject);
    procedure CopyMenuItemClick(Sender: TObject);
    procedure PasteMenuItemClick(Sender: TObject);
    procedure DeleteMenuItemClick(Sender: TObject);
    procedure SelectAllMenuItemClick(Sender: TObject);
    procedure ClearMenuItemClick(Sender: TObject);
    procedure ClearAllMenuItemClick(Sender: TObject);
    procedure FindMenuItemClick(Sender: TObject);
    procedure FindNextMenuItemClick(Sender: TObject);
    procedure FindBraceMenuItemClick(Sender: TObject);
    procedure ReplaceMenuItemClick(Sender: TObject);
    procedure GotoLineMenuItemClick(Sender: TObject);
    procedure FontMenuItemClick(Sender: TObject);
    procedure ReadOnlyMenuItemClick(Sender: TObject);
    procedure InsertModeMenuItemClick(Sender: TObject);
    procedure SetBookmarkMenuItemClick(Sender: TObject);
    procedure FindBookmarkMenuItemClick(Sender: TObject);
    procedure ForeColorMenuItemClick(Sender: TObject);
    procedure BackgroundColor1Click(Sender: TObject);
    procedure SelectForeColorMenuItemClick(Sender: TObject);
    procedure SelectBackColorMenuItemClick(Sender: TObject);
    procedure LEditChange(Sender: TObject);
    procedure UpdateMenuItems(Value: Boolean);
    procedure AboutMenuItemClick(Sender: TObject);
  private
    procedure ShowHint(Sender: TObject);
  public
  end;

var
  LEditForm: TLEditForm;

implementation

{$R *.DFM}

uses ledlp_1z;

procedure TLEditForm.FormCreate(Sender: TObject);
begin
  { Set up the application }
  Application.OnHint := ShowHint;
  {UpdateMenuItems(False); }
  Application.HintColor := clAqua;
  Application.HintPause := 0;
end;

procedure TLEditForm.ShowHint(Sender: TObject);
begin
  StatusLine.Caption := Application.Hint;
end;

procedure TLEditForm.ExitMenuItemClick(Sender: TObject);
begin
  { End the application }
  Close;
end;

procedure TLEditForm.OpenMenuItemClick(Sender: TObject);
begin
  { Load a file into LEdit }
  LEdit1.OpenFile;
end;

procedure TLEditForm.NewMenuItemClick(Sender: TObject);
begin
  { Start a new file in LEdit }
  LEdit1.NewFile;
  {UpdateMenuItems(False); }
end;

procedure TLEditForm.SaveMenuItemClick(Sender: TObject);
begin
  { Save the current LEdit contents to a file }
  LEdit1.SaveFile;
end;

procedure TLEditForm.SaveAsMenuItemClick(Sender: TObject);
begin
  { Save the current LEdit contents to a new file }
  LEdit1.SaveFileAs;
end;

procedure TLEditForm.ReloadFileMenuItemClick(Sender: TObject);
begin
  { Reload the current file into LEdit }
  LEdit1.ReloadFile;
end;

procedure TLEditForm.UndoMenuItemClick(Sender: TObject);
begin
  { Undo the last action }
  LEdit1.Undo;
  if LEdit1.CanRedo then
  begin
    RedoMenuItem.Enabled := True;
    RedoBtn.Enabled := True;
  end
  else
  begin
    RedoMenuItem.Enabled := False;
    RedoBtn.Enabled := False;
  end;
end;

procedure TLEditForm.RedoMenuItemClick(Sender: TObject);
begin
  { Redo the last undo }
  LEdit1.Redo;
  if LEdit1.CanUndo then
  begin
    UndoMenuItem.Enabled := True;
    UndoBtn.Enabled := True;
  end
  else
  begin
    UndoMenuItem.Enabled := False;
    UndoBtn.Enabled := False;
  end;
end;

procedure TLEditForm.ClearUndoMenuItemClick(Sender: TObject);
begin
  { Clear the undo buffer }
  LEdit1.EmptyUndoBuffer;
  { Set the undo menu item status }
  if LEdit1.CanUndo then
  begin
    UndoMenuItem.Enabled := True;
    UndoBtn.Enabled := True;
  end
  else
  begin
    UndoMenuItem.Enabled := False;
    UndoBtn.Enabled := False;
  end;
  { Set the redo menu item status }
  if LEdit1.CanRedo then
  begin
    RedoMenuItem.Enabled := True;
    RedoBtn.Enabled := True;
  end
  else
  begin
    RedoMenuItem.Enabled := False;
    RedoBtn.Enabled := False;
  end;
end;

procedure TLEditForm.CutMenuItemClick(Sender: TObject);
begin
  { Cut the selection and place it on the windows clipboard }
  LEdit1.CutToClipboard;
end;

procedure TLEditForm.CopyMenuItemClick(Sender: TObject);
begin
  { Copy the selection to the windows clipboard but do not cut it }
  LEdit1.CopyToClipboard;
end;

procedure TLEditForm.PasteMenuItemClick(Sender: TObject);
begin
  { Paste the contents of the windows clipboard into LEdit }
  LEdit1.PasteFromClipboard;
end;

procedure TLEditForm.DeleteMenuItemClick(Sender: TObject);
begin
  { Delete the selected text }
  LEdit1.ClearSelection;
end;

procedure TLEditForm.SelectAllMenuItemClick(Sender: TObject);
begin
  { Select all the text in LEdit }
  LEdit1.SelectAll;
end;

procedure TLEditForm.ClearMenuItemClick(Sender: TObject);
begin
  { Clear the selected text from LEdit }
  LEdit1.ClearSelection;
end;

procedure TLEditForm.ClearAllMenuItemClick(Sender: TObject);
begin
  { Clear all the text from LEdit }
  LEdit1.Clear;
end;

procedure TLEditForm.FindMenuItemClick(Sender: TObject);
begin
  { Show the Find dialog to perform a search }
  LEdit1.ShowFindDialog;
end;

procedure TLEditForm.FindNextMenuItemClick(Sender: TObject);
begin
  { Find the next occurance of the search }
  LEdit1.FindNext;
end;

procedure TLEditForm.FindBraceMenuItemClick(Sender: TObject);
begin
  { Find the next brace }
  LEdit1.FindBrace;
end;

procedure TLEditForm.ReplaceMenuItemClick(Sender: TObject);
begin
  { Show the Replace dialog to replace text searched for }
  LEdit1.ShowReplaceDialog;
end;

procedure TLEditForm.GotoLineMenuItemClick(Sender: TObject);
begin
  { Show the Goto Line dialog to go to a specific line }
  LEdit1.ShowGotoLineDialog;
end;

procedure TLEditForm.FontMenuItemClick(Sender: TObject);
begin
  { Show the Font dialog to set the font }
  LEdit1.ShowFontDialog;
end;

procedure TLEditForm.ReadOnlyMenuItemClick(Sender: TObject);
begin
  { Toggle LEdit to Read only or not Read Only mode }
  ReadOnlyMenuItem.Checked := not ReadOnlyMenuItem.Checked;
  LEdit1.ReadOnly := not LEdit1.ReadOnly;
end;

procedure TLEditForm.InsertModeMenuItemClick(Sender: TObject);
begin
  { Toggle LEdit to Insert or Overwrite mode }
  InsertModeMenuItem.Checked := not InsertModeMenuItem.Checked;
  LEdit1.InsertMode := not LEdit1.InsertMode;
end;

procedure TLEditForm.SetBookmarkMenuItemClick(Sender: TObject);
begin
  { Set a bookmark }
  LEdit1.SetBookmark;
end;

procedure TLEditForm.FindBookmarkMenuItemClick(Sender: TObject);
begin
  { Go to the bookmark }
  LEdit1.FindBookmark;
end;

procedure TLEditForm.ForeColorMenuItemClick(Sender: TObject);
begin
  { Display a color dialog and set the foreground (text) color of LEdit }
  if ColorDialog.Execute then
    LEdit1.Font.Color := ColorDialog.Color;
end;

procedure TLEditForm.BackgroundColor1Click(Sender: TObject);
begin
  { Display a color dialog and set the background color of LEdit }
  if ColorDialog.Execute then
    LEdit1.Color := ColorDialog.Color;
end;

procedure TLEditForm.SelectForeColorMenuItemClick(Sender: TObject);
begin
  { Display a color dialog and set the selection foreground color of LEdit }
  if ColorDialog.Execute then
    LEdit1.ForeColorSelected := ColorDialog.Color;
end;

procedure TLEditForm.SelectBackColorMenuItemClick(Sender: TObject);
begin
  { Display a color dialog and set the selection background color of LEdit }
  if ColorDialog.Execute then
    LEdit1.BackColorSelected := ColorDialog.Color;
end;

procedure TLEditForm.LEditChange(Sender: TObject);
begin
  { Set the status bar counts }
  TotalLineCount.Caption := IntToStr(LEdit1.LineCount);
  LEdit1.GetSelection;
  LineNumber.Caption := IntToStr(LEdit1.EndLine);
  RowNumber.Caption := IntToStr(LEdit1.EndPos);
  UpdateMenuItems(True);
end;

procedure TLEditForm.UpdateMenuItems(Value: Boolean);
begin
  SaveMenuItem.Enabled := Value;
  SaveAsMenuItem.Enabled := Value;
  ReloadFileMenuItem.Enabled := Value;
  CutMenuItem.Enabled := Value;
  CopyMenuItem.Enabled := Value;
  PasteMenuItem.Enabled := Value;
  DeleteMenuItem.Enabled := Value;
  SelectAllMenuItem.Enabled := Value;
  ClearMenuItem.Enabled := Value;
  ClearAllMenuItem.Enabled := Value;
  FindMenuItem.Enabled := Value;
  FindNextMenuItem.Enabled := Value;
  FindBraceMenuItem.Enabled := Value;
  ReplaceMenuItem.Enabled := Value;
  GotoLineMenuItem.Enabled := Value;
  SetBookmarkMenuItem.Enabled := Value;
  FindBookmarkMenuItem.Enabled := Value;
  SaveBtn.Enabled := Value;
  SaveAsBtn.Enabled := Value;
  ReloadBtn.Enabled := Value;
  CutBtn.Enabled := Value;
  CopyBtn.Enabled := Value;
  PasteBtn.Enabled := Value;
  FindBtn.Enabled := Value;
  ReplaceBtn.Enabled := Value;
  GotoBtn.Enabled := Value;
  SetBookmarkBtn.Enabled := Value;
  FindBookmarkBtn.Enabled := Value;
  { Set the undo menu item status }
  if LEdit1.CanUndo then
  begin
    UndoMenuItem.Enabled := True;
    UndoBtn.Enabled := True;
  end
  else
  begin
    UndoMenuItem.Enabled := False;
    UndoBtn.Enabled := False;
  end;
  { Set the redo menu item status }
  if LEdit1.CanRedo then
  begin
    RedoMenuItem.Enabled := True;
    RedoBtn.Enabled := True;
  end
  else
  begin
    RedoMenuItem.Enabled := False;
    RedoBtn.Enabled := False;
  end;
end;

procedure TLEditForm.AboutMenuItemClick(Sender: TObject);
begin
  { Show about box }
  LEExAboutBox.ShowModal;
end;

end.
